<ol class="page-breadcrumb">
  [[> Partial:breadcrumb iri=(resolvePrefix ":Start") label="Home"]]
  <li>
    Search
  </li>
</ol>

[[> Partial:contentStart]]

[[> Partial:pageHeader title="Search"]]

<h3>Form Based Search</h3>

<semantic-search>

  <!--

    By including a domain attribute in the semantic-search-form-query, e.g.
      domain='<http://ontologies.mpiwg-berlin.mpg.de/ismi/Person>'
    It is possible to combine form based search with facets.
    1. add domain
    2. include search settings in semantic-search
    3. add <semantic-search-facet></semantic-search-facet>

  -->

  <semantic-search-form-query

    query-template='{
        "queryString": "
          SELECT ?subject WHERE { 
            ?subject a ?class; 
            rdfs:label ?stringLabel.

            ?stringLabel bds:search ?label .
          }",
        "arguments": {
          "class": {"type": "xsd:anyURI", "optional": true},
          "label": {"type": "xsd:string"}
        }
    }'

    fields='[
      {
        "id": "class",
        "label": "Type",
        "description": "The type of the instance.",
        "xsdDatatype": "xsd:anyURI",
        "minOccurs": "0",
        "valueSetPattern": "
          SELECT $value $label WHERE {
            VALUES ($value $label) { 
              ( ismi:Person \"Person\" )
              ( ismi:Text \"Text\" )
              ( ismi:Witness \"Witness\" )
              ( ismi:Codex \"Codex\" )
           } 
         }",
        "selectPattern": "SELECT $value WHERE { $subject a $value }"
      },

      {
        "id": "label",
        "label": "Label",
        "description": "Will search for the term in the labels.",
        "minOccurs": "1",
        "xsdDatatype":"xsd:string"
      }
    ]'>

    <semantic-form-select-input placeholder='Please select a class to search instances of' for="class"></semantic-form-select-input>
    <semantic-form-text-input for="label" placeholder='Enter a (part of) a label you would like to search for'></semantic-form-text-input>

    <button type='button' name='submit' className='btn btn-default'>Search</button>

  </semantic-search-form-query>
  
  <semantic-search-result-holder>
    <semantic-search-result>
      <div class="panel gap">
        <div class="panel-body">
          <semantic-table 
          id='table' 
          query='SELECT ?subject ?label ?ismi_id WHERE {
            ?subject rdfs:label ?label .
            OPTIONAL {
             ?subject crm:P1_is_identified_by ?id .
             ?id crm:P2_has_type ismiidtype:ismi-id ;
              rdfs:label ?ismi_id . 
            }
          }'
          number-of-displayed-rows=100
          column-configuration='[
            { "variableName": "subject", "displayName": "Name" },
            { "variableName": "ismi_id", "displayName": "ID" }
          ]'
          options='{"showFilter": false}'>
        </semantic-table> 
        </div>
      </div>
    </semantic-search-result>
  </semantic-search-result-holder>
</semantic-search>


<h3>Structured Search</h3>

<semantic-search
  [[> Partial:semanticSearchSettings]]
>
  <semantic-search-query-builder></semantic-search-query-builder>

  <semantic-search-facet></semantic-search-facet>

  <semantic-search-result-holder>
    <semantic-search-result> 
      <div class="panel gap">
        <div class="panel-body">
          <semantic-table 
          id='table' 
          query='SELECT ?subject ?label ?ismi_id WHERE {
            ?subject rdfs:label ?label .
            OPTIONAL {
            ?subject crm:P1_is_identified_by ?id .
            ?id crm:P2_has_type ismiidtype:ismi-id ;
              rdfs:label ?ismi_id . 
            }
          }'
          number-of-displayed-rows=100
          column-configuration='[
            { "variableName": "subject", "displayName": "Name" },
            { "variableName": "ismi_id", "displayName": "ID" }
          ]'
          options='{"showFilter": false}'>
        </semantic-table> 
        </div>
      </div>
    </semantic-search-result>
  </semantic-search-result-holder>
</semantic-search>

[[> Partial:contentEnd]]
